/************************************************************************************************/
/**
* @file               common.c
* @author             MCU Ecosystem Development Team
* @brief              通用函数或本外设相关的配置实现函数。
*
*
**************************************************************************************************
* @attention
* Copyright (c) CEC Huada Electronic Design Co.,Ltd. All rights reserved.
*
**************************************************************************************************
*/

/*------------------------------------------includes--------------------------------------------*/
#include "common.h"

/*------------------------------------------define----------------------------------------------*/    

/*------------------------------------------functions-------------------------------------------*/
/**
* @brief  系统时钟配置
* @retval 无
*/
void system_clock_config(void)    
{
    uint32_t ahbdiv_tmp;
    
    /* 设置Flash读访问等待时间 */
    std_flash_set_latency(FLASH_LATENCY_1CLK);

    /* 使能RCH */
    std_rcc_rch_enable();
    while(!std_rcc_get_rch_ready());
    
    /* 备份AHB分频参数 */
    ahbdiv_tmp = std_rcc_get_ahbdiv();    
    /* 配置AHB最大分频：128分频 */
    std_rcc_set_ahbdiv(RCC_HCLK_DIV128);  
    
    /* 切换RCH4到RCH48 */    
    std_rcc_set_rch_source(RCC_RCH_FREQ_48M);
    /* 恢复AHB分频参数 */
    std_rcc_set_ahbdiv(ahbdiv_tmp);   

    /* 设置系统时钟源为RCH */
    std_rcc_set_sysclk_source(RCC_SYSCLK_SRC_RCH);
    while(std_rcc_get_sysclk_source() != RCC_SYSCLK_SRC_STATUS_RCH);

    /* 设置AHB分频因子 */
    std_rcc_set_ahbdiv(RCC_HCLK_DIV1);
    /* 设置APB分频因子 */
    std_rcc_set_apbdiv(RCC_PCLK_DIV1);
    
    SystemCoreClockUpdate();    
}


/**
* @brief  COMP初始化
* @note   初始化COMP1和COMP2作为窗口比较器
* @retval 无
*/
void comp_init(void)
{
    std_comp_init_t comp_config = {0};

    /* 使能COMP时钟 */
    std_rcc_apb2_clk_enable(RCC_PERIPH_CLK_COMP);
    
    /* 设置RDAC输出分压选择5/8级 */
    std_comp_set_rdac_div(COMP_RDAC_DIV_5DIV8);

    /* RDAC使能 */
    std_comp_rdac_enable();

    /* COMP1初始化 */
    comp_config.inpsel = COMP_INPSEL_IO1;                     /* COMP1正相输入为PA9引脚 */
    comp_config.inmsel = COMP_INMSEL_VRDAC_OUT;               /* 反相输入VRDAC_OUT */
    comp_config.speed = COMP_LOWSPEED;                        /* 低响应速度 */
    comp_config.hyst = COMP_HYST_DISABLE;                     /* 禁止迟滞功能 */
    comp_config.outpol = COMP_OUTPOL_NON_INVERTED;            /* 输出不反相 */
    comp_config.interrupt_type = COMP_INTERRUPT_TYPE_NONE;    /* 不触发中断 */
    comp_config.filter_enable = COMP_FILTER_DISABLE;          /* 滤波禁止 */
    std_comp_init(COMP1, &comp_config);

    std_comp_set_input_plus_mode(COMP1, COMP_INPMODE_EACH_INPUT); /* COMP1输入独立，非窗口比较器模式 */
    std_comp_set_output_mode(COMP1, COMP_OUTMODE_COMMON_XOR_OUT); /* 比较器输出为比较器1、2电压比较结果异或 */

    /* COMP2初始化 */
    comp_config.inmsel = COMP_INMSEL_IO1;                     /* COMP2反相输入为PF1引脚 */
    comp_config.speed = COMP_LOWSPEED;                        /* 低响应速度 */
    comp_config.hyst = COMP_HYST_DISABLE;                     /* 禁止迟滞 */
    comp_config.outpol = COMP_OUTPOL_NON_INVERTED;            /* 输出不反相 */
    comp_config.interrupt_type = COMP_INTERRUPT_TYPE_NONE;    /* 不触发中断 */
    comp_config.filter_enable = COMP_FILTER_DISABLE;          /* 滤波禁止 */
    std_comp_init(COMP2, &comp_config);

    std_comp_set_input_plus_mode(COMP2, COMP_INPMODE_COMMON_INPUT); /* COMP2窗口比较器模式：COMP2的正相输入来自COMP1的正相输入 */
    std_comp_set_output_mode(COMP2, COMP_OUTMODE_EACH_OUT);         /* COMP2输出独立，为其原始信号输出 */
    
    /* 使能COMP1 */
    std_comp_enable(COMP1);

    /* 使能COMP2 */
    std_comp_enable(COMP2);

    /* 等待COMP使能启动时间 
       响应速度模式为高速, 使能启动时间1US
       响应速度模式为低速, 使能启动时间6US
    */
    std_delayus(COMP_EN_DELAY);
}

/**
* @brief  GPIO初始化
* @retval 无
*/
void gpio_init(void)
{
    std_gpio_init_t comp_gpio_config = {0};
    std_gpio_init_t led_gpio_config = {0};
 
    std_rcc_gpio_clk_enable(RCC_PERIPH_CLK_GPIOA | RCC_PERIPH_CLK_GPIOB | RCC_PERIPH_CLK_GPIOF);
    
    /* 配置COMP1正相输入GPIO模拟模式 */
    comp_gpio_config.pin = GPIO_PIN_9;
    comp_gpio_config.mode = GPIO_MODE_ANALOG;
    std_gpio_init(GPIOA, &comp_gpio_config);
    
    /* 配置COMP1输出IO PA10 */
    comp_gpio_config.pin = GPIO_PIN_10;
    comp_gpio_config.mode = GPIO_MODE_ALTERNATE;
    comp_gpio_config.alternate = GPIO_AF7_COMP1;
    std_gpio_init(GPIOA, &comp_gpio_config);
   
    /* 配置COMP2反相输入GPIO模拟模式 */
    comp_gpio_config.pin = GPIO_PIN_1;
    comp_gpio_config.mode = GPIO_MODE_ANALOG;
    std_gpio_init(GPIOF, &comp_gpio_config);
    
    /* LED1初始化 */
    led_gpio_config.pin = LED1_PIN;
    led_gpio_config.mode = GPIO_MODE_OUTPUT;
    led_gpio_config.output_type = GPIO_OUTPUT_PUSHPULL;
    led_gpio_config.pull = GPIO_NOPULL;
    std_gpio_init(LED1_GPIO_PORT, &led_gpio_config);
    
    /* 熄灭LED1 */
    LED1_OFF();
}
